# Traditionelle Conjointanalyse mit R: HB-Schtzung (cola_TCA_HB.r)
# 1. Einlesen der Prferenzwerte und der Stimulusbeschreibungen:
setwd("C:/Users/Alpha/Conjointanalyse/Cola/R")
I=199; J=25; K=6; L=c(3,4,3,2,4,4); p=1+sum(L)
Data=read.csv("cola_pwert.csv",sep=","); Data=as.matrix(Data[,3:27])
Plan=read.csv("cola_plan.csv",sep=";"); Plan=Plan[1:J,1:K]
# 2. HB-Schtzung der Teilnutzenwerte (Gibbs Sampling)
library(bayesm); regdata=NULL
for (k in 1:K){Plan[,k]=as.factor(Plan[,k])}
X=as.matrix(model.matrix(~.,data=Plan))
for (i in 1:I) {y=as.vector(t(Data[i,]));regdata[[i]]=list(y=y, X=X)}
Data=list(regdata=regdata); Mcmc <- list(R=20000)
fit=rhierLinearModel(Data=Data,Mcmc=Mcmc)
# 3. bertragung normierter Werte nach u und w:
u=matrix(0,nrow=I,ncol=p); w=matrix(0,nrow=I,ncol=K); b=1:(1+sum(L)-K)
for (i in 1:I){# ber alle Personen
  for (j in 1:1+sum(L)-K){b[j]=mean(as.vector(fit$betadraw[i,j,
           10001:20000]))}
  ix=1; u[i,ix]=b[ix]; wsum=0
  for (k in 1:K) {for (l in 2:L[k]) {u[i,ix+l]=b[ix-k+l]}
    w[i,k]=max(u[i,(ix+1):(ix+L[k])])-min(u[i,(ix+1):(ix+L[k])])
    wsum=wsum+w[i,k]; delta=sum(u[i,(ix+1):(ix+L[k])])/L[k]
    for (l in 1:L[k]) {u[i,ix+l]=u[i,ix+l]-delta}
    u[i,1]=u[i,1]+delta; ix=ix+L[k]}
  for (k in 1:K) {w[i,k]=w[i,k]/wsum}
}; for (k in 1:K) {print(mean(w[,k]))} # mittlere Wichtigkeiten
for (l in 1:p) {print(mean(u[,l]))} # mittlere Nutzenbeitrge
